!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     ######spl
      MODULE MODN_SURF_ATM_n
!     ######################
!
!!****  *MODN_SURF_ATM_n* - declaration of namelist NAM_SURF_ATMn
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_SURF_ATMn
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      P. Tulet    flag namelist  for emission      02/2004  
!!      B. Decharme Cumulative diag for all Tile     08/2009
!!      B. Decharme Key to allow (or not) writting diag   10/2009
!!      S.Senesi    Additional write selection mechanism   12/2009
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_DIAG_SURF_ATM_n, ONLY: &
           XDIAG_TSTEP_n => XDIAG_TSTEP, &
           N2M_n => N2M, &
           L2M_MIN_ZS_n => L2M_MIN_ZS, &
           LSURF_BUDGET_n => LSURF_BUDGET, &
           LRAD_BUDGET_n => LRAD_BUDGET, &
           LSURF_BUDGETC_n => LSURF_BUDGETC, &
           LRESET_BUDGETC_n => LRESET_BUDGETC, &
           LFRAC_n => LFRAC,&
           LCOEF_n => LCOEF,&
           LSURF_VARS_n => LSURF_VARS,&
           LDIAG_GRID_n => LDIAG_GRID,&
           LPROVAR_TO_DIAG_n => LPROVAR_TO_DIAG,&
           LSELECT_n => LSELECT,&
           CSELECT_n => CSELECT  

USE MODD_CH_SURF_n, ONLY: &
           CCHEM_SURF_FILE_n => CCHEM_SURF_FILE, &
           LCH_SURF_EMIS_n => LCH_SURF_EMIS  
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=28), SAVE  :: CCHEM_SURF_FILE
LOGICAL, SAVE  :: LCH_SURF_EMIS
LOGICAL  :: LFRAC
REAL     :: XDIAG_TSTEP
INTEGER  :: N2M
LOGICAL  :: L2M_MIN_ZS
LOGICAL  :: LSURF_BUDGET
LOGICAL  :: LRAD_BUDGET
LOGICAL  :: LSURF_BUDGETC
LOGICAL  :: LRESET_BUDGETC
LOGICAL  :: LCOEF
LOGICAL  :: LSURF_VARS
LOGICAL  :: LDIAG_GRID
LOGICAL  :: LPROVAR_TO_DIAG
LOGICAL  :: LSELECT
 CHARACTER(LEN=12), DIMENSION(250)    :: CSELECT
!
NAMELIST/NAM_CH_CONTROLn/CCHEM_SURF_FILE
NAMELIST/NAM_CH_SURFn/LCH_SURF_EMIS
NAMELIST/NAM_DIAG_SURF_ATMn/LFRAC, LDIAG_GRID
NAMELIST/NAM_DIAG_SURFn/N2M, L2M_MIN_ZS, LSURF_BUDGET, LRAD_BUDGET, LSURF_BUDGETC,  &
                          LRESET_BUDGETC, LCOEF, LSURF_VARS  
!                        
NAMELIST/NAM_WRITE_DIAG_SURFn/LPROVAR_TO_DIAG,LSELECT,CSELECT
!
CONTAINS
!
SUBROUTINE INIT_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE = CCHEM_SURF_FILE_n
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_CONTROLn

SUBROUTINE UPDATE_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE_n = CCHEM_SURF_FILE
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_CONTROLn

SUBROUTINE INIT_NAM_CH_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_CH_SURFN',0,ZHOOK_HANDLE)
  LCH_SURF_EMIS = LCH_SURF_EMIS_n
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_CH_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_SURFn

SUBROUTINE UPDATE_NAM_CH_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_CH_SURFN',0,ZHOOK_HANDLE)
  LCH_SURF_EMIS_n = LCH_SURF_EMIS
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_CH_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_SURFn

SUBROUTINE INIT_NAM_DIAG_SURF_ATMn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_DIAG_SURF_ATMN',0,ZHOOK_HANDLE)
  LFRAC = LFRAC_n
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_DIAG_SURF_ATMN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURF_ATMn

SUBROUTINE UPDATE_NAM_DIAG_SURF_ATMn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_DIAG_SURF_ATMN',0,ZHOOK_HANDLE)
  LFRAC_n = LFRAC
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_DIAG_SURF_ATMN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURF_ATMn

SUBROUTINE INIT_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP = XDIAG_TSTEP_n
  N2M = N2M_n
  L2M_MIN_ZS = L2M_MIN_ZS_n
  LSURF_BUDGET = LSURF_BUDGET_n
  LRAD_BUDGET = LRAD_BUDGET_n
  LSURF_BUDGETC = LSURF_BUDGETC_n
  LRESET_BUDGETC = LRESET_BUDGETC_n
  LCOEF = LCOEF_n
  LSURF_VARS = LSURF_VARS_n
  LDIAG_GRID = LDIAG_GRID_n
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURFn

SUBROUTINE UPDATE_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP_n = XDIAG_TSTEP
  N2M_n = N2M
  L2M_MIN_ZS_n = L2M_MIN_ZS
  LSURF_BUDGET_n = LSURF_BUDGET
  LRAD_BUDGET_n = LRAD_BUDGET
  LSURF_BUDGETC_n = LSURF_BUDGETC
  LRESET_BUDGETC_n = LRESET_BUDGETC 
  LCOEF_n = LCOEF
  LSURF_VARS_n = LSURF_VARS
  LDIAG_GRID_n = LDIAG_GRID
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURFn


SUBROUTINE INIT_NAM_WRITE_DIAG_SURFn


  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_WRITE_DIAG_SURFN',0,ZHOOK_HANDLE)
  LPROVAR_TO_DIAG = LPROVAR_TO_DIAG_n
  LSELECT = LSELECT_n
  CSELECT(:) = '            '
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:INIT_NAM_WRITE_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_WRITE_DIAG_SURFn

SUBROUTINE UPDATE_NAM_WRITE_DIAG_SURFn
  INTEGER :: ICOUNT
  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_WRITE_DIAG_SURFN',0,ZHOOK_HANDLE)
  LPROVAR_TO_DIAG_n = LPROVAR_TO_DIAG
!
  LSELECT_n = LSELECT
  IF (LSELECT) THEN
    ICOUNT = COUNT(CSELECT /= '            ')
    IF(.NOT.ASSOCIATED(CSELECT_n))THEN
      ALLOCATE(CSELECT_n(ICOUNT))
      CSELECT_n(:) = '            '
    ENDIF
    CSELECT_n = CSELECT(1:ICOUNT)
  ENDIF
IF (LHOOK) CALL DR_HOOK('MODN_SURF_ATM_N:UPDATE_NAM_WRITE_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_WRITE_DIAG_SURFn

END MODULE MODN_SURF_ATM_n
