!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
SUBROUTINE READ_ALL_NAMELISTS(HPROGRAM,HINIT,ONAM_READ)
!
USE MODD_SURF_ATM_n, ONLY: CSEA, CWATER, CNATURE, CTOWN, LGARDEN, &
                  NDIM_SEA, NDIM_WATER, NDIM_NATURE, NDIM_TOWN  
!
USE MODD_READ_NAMELIST, ONLY : LNAM_READ
!
USE MODI_INIT_READ_DATA_COVER
!
USE MODI_READ_NAMELISTS_SURF_n
USE MODI_READ_NAMELISTS_SURF
USE MODI_READ_NAMELISTS_FLAKE_n
USE MODI_READ_NAMELISTS_WATFLUX_n
USE MODI_READ_NAMELISTS_SEAFLUX_n
USE MODI_READ_NAMELISTS_ISBA_n
USE MODI_READ_NAMELISTS_ISBA
USE MODI_READ_NAMELISTS_TEB_n
USE MODI_READ_NAMELISTS_IDEAL_n
USE MODI_READ_NAMELISTS_IDEAL
USE MODI_READ_NAMELISTS_TRIP_n
USE MODI_READ_NAMELISTS_SLT
USE MODI_READ_NAMELISTS_DST
USE MODI_READ_NAMELISTS_ASSIM
USE MODI_READ_NAMELISTS_TOPD
!
USE MODI_READ_NAM_PREP_FLAKE_n
USE MODI_READ_NAM_PREP_GARDEN_n
USE MODI_READ_NAM_PREP_GREENROOF_n
USE MODI_READ_NAM_PREP_ISBA_n
USE MODI_READ_NAM_PREP_SEAFLUX_n
USE MODI_READ_NAM_PREP_SURF_n
USE MODI_READ_NAM_PREP_TEB_n
USE MODI_READ_NAM_PREP_WATFLUX_n
!
!--------------------------------------------------
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=6),  INTENT(IN)   :: HPROGRAM  ! program calling surf. schemes
 CHARACTER(LEN=3),   INTENT(IN)  :: HINIT     ! choice of fields to initialize
LOGICAL,INTENT(IN)              :: ONAM_READ
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!----------------------------------------
!namelists always read here
!
IF (LHOOK) CALL DR_HOOK('READ_ALL_NAMELISTS',0,ZHOOK_HANDLE)
LNAM_READ=.TRUE.
!
 CALL INIT_READ_DATA_COVER(HPROGRAM)
!
 CALL READ_NAMELISTS_SURF(HPROGRAM)
 CALL READ_NAMELISTS_ISBA(HPROGRAM)
 CALL READ_NAMELISTS_SLT(HPROGRAM)
 CALL READ_NAMELISTS_DST(HPROGRAM)
 CALL READ_NAMELISTS_IDEAL(HPROGRAM)
 CALL READ_NAMELISTS_ASSIM(HPROGRAM)
 CALL READ_NAMELISTS_TOPD(HPROGRAM)
!
IF (HPROGRAM=='AROME ') THEN
#ifdef ARO
  CALL READ_NAMELISTS_IO(HPROGRAM)
#endif
ENDIF
!
LNAM_READ = ONAM_READ
!
!namelists that can be reread in surfex code
!
IF (.NOT.LNAM_READ) THEN
! 
  LNAM_READ=.TRUE.
  !
  CALL READ_NAMELISTS_SURF_n(HPROGRAM,HINIT)
  !
  CALL READ_NAMELISTS_FLAKE_n(HPROGRAM,HINIT)
  CALL READ_NAMELISTS_WATFLUX_n(HPROGRAM,HINIT)
  CALL READ_NAMELISTS_SEAFLUX_n(HPROGRAM,HINIT)
  CALL READ_NAMELISTS_ISBA_n(HPROGRAM,HINIT)
  CALL READ_NAMELISTS_TEB_n(HPROGRAM,HINIT)
  CALL READ_NAMELISTS_IDEAL_n(HPROGRAM)
  CALL READ_NAMELISTS_TRIP_n(HPROGRAM)
  !
  LNAM_READ=.FALSE.
  !
  !prep namelists, to be read even if reread in surfex code, 
  !because only partially reread
  !
ELSEIF (HINIT=='PRE') THEN
  !
  CALL READ_NAM_PREP_SURF_n(HPROGRAM)
  CALL READ_NAM_PREP_FLAKE_n(HPROGRAM)
  CALL READ_NAM_PREP_WATFLUX_n(HPROGRAM)
  CALL READ_NAM_PREP_SEAFLUX_n(HPROGRAM) 
  CALL READ_NAM_PREP_ISBA_n(HPROGRAM)
  CALL READ_NAM_PREP_GARDEN_n(HPROGRAM)
  CALL READ_NAM_PREP_GREENROOF_n(HPROGRAM)
  CALL READ_NAM_PREP_TEB_n(HPROGRAM)
  !
ENDIF
!
IF (LHOOK) CALL DR_HOOK('READ_ALL_NAMELISTS',1,ZHOOK_HANDLE)
!-------------------------------------------
END SUBROUTINE READ_ALL_NAMELISTS
